-- (c) M.P.I 98/99 -- Date: 98.12.03

module LList where

import Mpi

-- (1) Datatype definition -----------------------------------------------------

data LList a = Nil | Cons(a,LList a) deriving Show

inLList = either (const Nil) Cons

outLList Nil         = Left ()
outLList (Cons(a,x)) = Right(a,x)

-- (2) Ana + cata + hylo -------------------------------------------------------

cata g = g . (rec (cata g)) . outLList   

ana g = inLList . (rec (ana g) ) . g

hylo a c = (cata a) . (ana c)

rec f = id -|- (id >< f)

-- (3) Map ---------------------------------------------------------------------

instance Functor LList
         where map f = cata ( inLList . (id -|- (f >< id)))

-- (4) Examples ----------------------------------------------------------------

-- (4.1) Factorial--------------------------------------------------------------

fac = hylo (either cone mul) obsNat

-- where

cone = const 1

mul(x,y)=x*y

obsNat 0 = Left ()
obsNat n = Right (n,n-1)

-- (4.2) Insertion sort --------------------------------------------------------

iSort :: Ord a => [a] -> [a]
iSort = hylo (either (const []) insert) conv

-- where

conv []    = Left  ()
conv (h:t) = Right (h,t)

insert(x,[])              = [x]
insert(x,a:l) | x < a     = [x,a]++l
              | otherwise = a:(insert(x,l))

--------------------------------------------------------------------------------

